[llvm] r180587 - Added the scripts git-svnup/git-svnrevert to utils/git-svn.
Michael Gottesman
mgottesman at apple.com
Thu Apr 25 17:58:45 PDT 2013
Author: mgottesman
Date: Thu Apr 25 19:58:45 2013
New Revision: 180587
URL: http://llvm.org/viewvc/llvm-project?rev=180587&view=rev
Log:
Added the scripts git-svnup/git-svnrevert to utils/git-svn.
It makes more sense to have git-svnup here than catting said file in the
documentation (where we should rather point users to this directory).
I included git-svnrevert as an additional gift to the community. I will update
the documentation in a second commit later today.
git-svnrevert takes in a git hash for a commit, looks up the svn revision for
said commit and then creates the normal git revert commit message with the one
liner message, except instead of saying
Revert "<<<INSERT ONELINER HERE>>>"
This reverts commit <<<INSERT GITHASH HERE>>>
It says:
Revert "<<<INSERT ONELINER HERE>>>"
This reverts commit r<<<INSERT SVN REVISION HERE>>>
so git hashes will not escape into our svn logs (which just look unseemly).
Added:
llvm/trunk/utils/git-svn/
llvm/trunk/utils/git-svn/git-svnrevert (with props)
llvm/trunk/utils/git-svn/git-svnup (with props)
Added: llvm/trunk/utils/git-svn/git-svnrevert
URL: http://llvm.org/viewvc/llvm-project/llvm/trunk/utils/git-svn/git-svnrevert?rev=180587&view=auto
==============================================================================
--- llvm/trunk/utils/git-svn/git-svnrevert (added)
+++ llvm/trunk/utils/git-svn/git-svnrevert Thu Apr 25 19:58:45 2013
@@ -0,0 +1,53 @@
+#!/bin/bash
+
+if [ $# -ne 1 ]; then
+ echo "Invalid arguments!"
+ echo "$0 <commit to revert>"
+ exit 1
+fi
+
+if [ -n "$(git status -uno -s --porcelain)" ]; then
+ echo "You have unstashed changes. Please stash and then revert."
+ git status -uno
+ exit 1
+fi
+
+COMMIT=$1
+
+SVN_REVISION=$(git log -1 $COMMIT | grep git-svn-id | tr -s "@" " " | cut -f 4 -d " ")
+
+if [ -z "$SVN_REVISION" ]; then
+ echo "Error! Given commit is not a git-svn revision!"
+ exit 1
+fi
+
+# Grab the one line message for our revert commit message.
+ONE_LINE_MSG=$(git log --oneline $COMMIT -1 | cut -f2- -d " ")
+
+# Revert the commit.
+git revert --no-commit $COMMIT 2>/dev/null
+if [ $? -ne 0 ]; then
+ echo "Error! Failed to revert commit $COMMIT. Resetting to head."
+ git reset --hard HEAD
+ exit 1
+fi
+
+# Create a template in our .git directory.
+TEMPLATE="`git rev-parse --git-dir`/git-svn-revert-template"
+cat > $TEMPLATE <<EOF
+Revert "$ONE_LINE_MSG"
+
+This reverts commit r$SVN_REVISION.
+EOF
+
+# Begin the commit but give our user an opportunity to edit it.
+git commit --file="$TEMPLATE" --edit
+if [ $? -ne 0 ]; then
+ echo "Error! Failed to commit reverting commit for commit $COMMIT. Reverting to head."
+ git reset --hard HEAD
+ rm -rf $TEMPLATE
+ exit 1
+fi
+
+rm -rf $TEMPLATE
+
Propchange: llvm/trunk/utils/git-svn/git-svnrevert
------------------------------------------------------------------------------
svn:executable = *
Added: llvm/trunk/utils/git-svn/git-svnup
URL: http://llvm.org/viewvc/llvm-project/llvm/trunk/utils/git-svn/git-svnup?rev=180587&view=auto
==============================================================================
--- llvm/trunk/utils/git-svn/git-svnup (added)
+++ llvm/trunk/utils/git-svn/git-svnup Thu Apr 25 19:58:45 2013
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+if [ -n "`git status -uno -s --porcelain`" ]; then
+ echo "You have unstashed changes. Can not update repository..."
+ git status -uno
+ exit 1
+fi
+
+git fetch
+OLD_BRANCH=$(git rev-parse --abbrev-ref HEAD)
+git checkout master 2> /dev/null
+git svn rebase -l
+git checkout $OLD_BRANCH 2> /dev/null
+
+exit 0
Propchange: llvm/trunk/utils/git-svn/git-svnup
------------------------------------------------------------------------------
svn:executable = *
More information about the llvm-commits
mailing list